Attribute VB_Name = "EnvironmentGrid"
Option Explicit

'this is a win API thingy :P
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)

'240 is 2x the size of the smallest bots.  So 1 such env grid cell can hold 4 bots.
Const GRIDTWIPX As Integer = 120
Const GRIDTWIPY As Integer = 120
Dim GridWidth As Long 'of grid to use
Dim GridHeight As Long 'of grid to use

Private Type Pheremone
  ID As Integer
  Amount As Integer
End Type
'maybe 4 bytes on average

Private Type GridSubstance
  softness As Integer
  stickyness As Integer
  inversesize As Integer 'how many can physically fit in a square
  inversemass As Integer 'how many units it takes to make 1 mass (used for collisions and digging)
End Type

Dim LookupSubstance(10) As GridSubstance

'Substance order:
'0 = Cement
'1 = Sand
'2 = Dirt
'3 = Clay
'4 = NRG
'5 =
'6 =
'7 =
'8 =
'9 =
'10=

Private Type GridSquare
  Pheremone(5) As Pheremone
  'Pheremones are emitted by cells as a method of prolonged communication
  'pheremones slowly fade, but do not diffuse (they are sticky)
  'only 5 pheremones are allowed per cell, with more populous
  'versions replacing less so
  '0-5 are these pheremones
  
  substance(10) As Integer
  'the type of substance is determined by it's place in the array
  'substances are organic and inorganic forms that define the environment
  'fixed array size for convienience.
  'increase as need arises
End Type
'~30 bytes on average

'800*600 is the max field size divided into 120*120 blocks
Private grid(800, 600) As GridSquare 'let's pretend this is a class.  Don't access these directly from outside the module
Private gridtemp(800, 600) As Integer 'used as a temp grid for substance diffusion
Private physgrid(160, 120) As SimSettings 'holds the simulation physics constants
'for use if the egrid is turned on to use different constant settings

Public Sub InitGrid()
  Erase grid
  Erase gridtemp
End Sub

Public Sub SetGridSize(ByVal Height As Long, ByVal width As Long)
  GridWidth = width / GRIDTWIPX
  GridHeight = Height / GRIDTWIPY
End Sub

Public Sub GridDiffuse()
  Dim x As Long
  Dim Y As Long
  Dim Sc As Integer
  Dim Diffuse As Single
  
  Diffuse = SimOpts.Diffuse / 12
  
  For Sc = 0 To 10
    Erase gridtemp
    For Y = 1 To GridHeight
      For x = 1 To GridWidth
        Dim substanceSC As Long
        
        substanceSC = (grid(x, Y).substance(Sc) * LookupSubstance(Sc).stickyness) / 100
        
        gridtemp(x - 1, Y - 1) = gridtemp(x - 1, Y - 1) + substanceSC * (Diffuse)
        gridtemp(x - 0, Y - 1) = gridtemp(x - 0, Y - 1) + substanceSC * (Diffuse * 2)
        gridtemp(x + 1, Y - 1) = gridtemp(x + 1, Y - 1) + substanceSC * (Diffuse)
        
        gridtemp(x - 1, Y - 0) = gridtemp(x - 1, Y - 0) + substanceSC * (Diffuse * 2)
        gridtemp(x - 0, Y - 0) = gridtemp(x - 0, Y - 0) + substanceSC * (1 - Diffuse * 12)
        gridtemp(x + 1, Y - 0) = gridtemp(x + 1, Y - 0) + substanceSC * (Diffuse * 2)
        
        gridtemp(x - 1, Y + 1) = gridtemp(x - 1, Y + 1) + substanceSC * (Diffuse)
        gridtemp(x - 0, Y + 1) = gridtemp(x - 0, Y + 1) + substanceSC * (Diffuse * 2)
        gridtemp(x + 1, Y + 1) = gridtemp(x + 1, Y + 1) + substanceSC * (Diffuse)
      Next x
    Next Y
    
    For Y = 1 To GridHeight
      For x = 1 To GridWidth
        grid(x, Y).substance(Sc) = gridtemp(x, Y)
      Next x
    Next Y
  Next Sc
  
  'pheremones don't diffuse
End Sub

Public Sub GridHard(ID As Long)
'Here's where we check if a grid cell can be moved through or not
'place this after all accelerations are figured out but before velocity
'is applied to the bots position.

'that is, velocity must tell us where it will be,
'while the bot's position tells us where it is

'Note that there's a threshold.  Below the threshold and sand, dirt, etc.
'just add to friction

'above this threshold and it acts like a solid wall.  This threshold can (or will)
'be user defined, but a good value is probably about 150, with 250 being the max
'sand + dirt + cement a cell can hold.
  Dim x As Long
  Dim Y As Long
  
  x = rob(ID).x + rob(ID).vx / GRIDTWIPX
  Y = rob(ID).Y + rob(ID).vy / GRIDTWIPY
  
  'check all possibly hard substances
End Sub
